package com.brilliance.isc.funds.crtcri.resource;

import com.brilliance.isc.common.context.SettleContext;
import com.brilliance.isc.common.transaction.controller.AbstractTransactionController;
import com.brilliance.isc.funds.crtcri.service.CrtcriTransactionServiceImpl;
import com.brilliance.isc.funds.transfer.transaction.CrtcriStructMapper;
import com.brilliance.isc.funds.vo.funds.CrtcriStoreVo;
import com.brilliance.isc.transfer.IStructMapper;
import com.brilliance.isc.vo.ResponseSet;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * @program: isc-funds
 * @ClassName: CrtcriResource
 * @description: 汇入清算 Crtcri 请求入口
 * @author: huangshunlin
 * @create: 2024-10-08 15:34
 */
@RestController
@RequestMapping("/crtcri")
@Api("汇入清算")
public class CrtcriResource extends AbstractTransactionController<CrtcriStoreVo> {

    @Resource
    private CrtcriStructMapper crtcriStructMapper;

    public IStructMapper getStructMapper() {
        return crtcriStructMapper;
    }

    @Resource(name = "crtcri.transaction")
    CrtcriTransactionServiceImpl crtcriTransactionService;

    @Autowired
    private SettleContext settleContext;

    /**
     * 获取业务参号
     *
     * @param crtcriStoreVo
     * @return
     */
    @PostMapping("/getRef")
    public ResponseSet<String> getRef(@RequestBody CrtcriStoreVo crtcriStoreVo) {
        String ref = crtcriTransactionService.getRef(crtcriStoreVo);
        return ResponseSet.simpleSuccess(ref);
    }



}
