package com.brilliance.isc.funds.crtcro.resource;

import com.brilliance.isc.common.context.SettleContext;
import com.brilliance.isc.common.transaction.controller.AbstractTransactionController;
import com.brilliance.isc.funds.crtcro.service.CrtcroTransactionServiceImpl;
import com.brilliance.isc.funds.transfer.transaction.CrtcroStructMapper;
import com.brilliance.isc.funds.vo.funds.CrtcroStoreVo;
import com.brilliance.isc.transfer.IStructMapper;
import com.brilliance.isc.vo.ResponseSet;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * @program: isc-funds
 * @ClassName: CrtcroResource
 * @description: 汇出清算 Crtcro 请求入口
 * @author: huangshunlin
 * @create: 2024-10-17 22:41
 */
@RestController
@RequestMapping("/crtcro")
@Api("汇入清算")
public class CrtcroResource extends AbstractTransactionController<CrtcroStoreVo> {

    @Resource
    private CrtcroStructMapper crtcroStructMapper;

    public IStructMapper getStructMapper() {
        return crtcroStructMapper;
    }

    @Resource(name = "crtcro.transaction")
    CrtcroTransactionServiceImpl crtcroTransactionService;

    @Autowired
    private SettleContext settleContext;

    /**
     * 获取业务参号
     *
     * @param crtcroStoreVo
     * @return
     */
    @PostMapping("/getRef")
    public ResponseSet<String> getRef(@RequestBody CrtcroStoreVo crtcroStoreVo) {
        String ref = crtcroTransactionService.getRef(crtcroStoreVo);
        return ResponseSet.simpleSuccess(ref);
    }


}
