package com.brilliance.isc.funds.fxtlcm.resource;

import com.brilliance.isc.common.context.SettleContext;
import com.brilliance.isc.common.transaction.controller.AbstractTransactionController;
import com.brilliance.isc.funds.fxtlcm.service.impl.FxtlcmTransactionServiceImpl;
import com.brilliance.isc.funds.transfer.transaction.FxtlcmStructMapper;
import com.brilliance.isc.funds.vo.funds.FxtlcmStoreVo;
import com.brilliance.isc.transfer.IStructMapper;
import com.brilliance.isc.vo.ResponseSet;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * @program: isc-funds
 * @ClassName: FxtlcmResource
 * @description:结售汇平盘确认 Fxtlcm
 * @author: Lenovo
 * @create: 2024-10-14 13:57
 */
@RestController
@RequestMapping("/fxtlcm")
@Api("结售汇平盘确认")
public class FxtlcmResource extends AbstractTransactionController<FxtlcmStoreVo> {

    @Resource
    private FxtlcmStructMapper fxtlcmStructMapper;

    public IStructMapper getStructMapper() {
        return fxtlcmStructMapper;
    }

    @Resource(name = "fxtlcm.transaction")
    FxtlcmTransactionServiceImpl fxtlcmTransactionService;

    @Autowired
    private SettleContext settleContext;

    @PostMapping("/getRef")
    public ResponseSet<String> getRef(@RequestBody FxtlcmStoreVo fxtlcmStoreVo) {
        String ref = fxtlcmTransactionService.getRef(fxtlcmStoreVo);
        return ResponseSet.simpleSuccess(fxtlcmStoreVo);
    }

}
